searchNodes=[{"doc":"Nex is a powerful and flexible Nostr relay written in Elixir. Elixir's highly scalabe nature means Nex can easily handle a large number of concurrent connections. Nex features built-in IP-based rate limiting, which can be configured to suit your specific needs. Run as a standalone service or plug in to an existing Plug-base or Phoenix application. Supported NIPs [x] NIP-01 - Basic protocol flow description [x] NIP-02 - Contact List and Petnames [x] NIP-04 - Encrypted Direct Messages [x] NIP-09 - Event Deletion [x] NIP-11 - Relay Information Document [x] NIP-12 - Generic Tag Queries [x] NIP-13 - Proof of Work [x] NIP-15 - End of Stored Events Notice [x] NIP-16 - Event Treatment [x] NIP-20 - Command Results [x] NIP-22 - Event created_at Limits [x] NIP-26 - Delegated Event Signing [x] NIP-28 - Public Chat [x] NIP-33 - Parameterized Replaceable Events [x] NIP-40 - Expiration Timestamp","ref":"Nex.html","title":"Nex","type":"module"},{"doc":"Returns the NIP-11 Relay Information Document map.","ref":"Nex.html#relay_info/1","title":"Nex.relay_info/1","type":"function"},{"doc":"Handler behaviour. Messages received to the Nex.Socket handler are routed to different modules that implement this behaviour.","ref":"Nex.Handler.html","title":"Nex.Handler","type":"behaviour"},{"doc":"Callback for handling message items. Must return a WebSock.handle_result/0 .","ref":"Nex.Handler.html#c:handle_item/2","title":"Nex.Handler.handle_item/2","type":"callback"},{"doc":"Event handler (implements Nex.Handler ).","ref":"Nex.Handlers.EventHandler.html","title":"Nex.Handlers.EventHandler","type":"module"},{"doc":"","ref":"Nex.Handlers.EventHandler.html#handle_default_event/2","title":"Nex.Handlers.EventHandler.handle_default_event/2","type":"function"},{"doc":"Message handler (implements Nex.Handler ).","ref":"Nex.Handlers.MessageHandler.html","title":"Nex.Handlers.MessageHandler","type":"module"},{"doc":"Subscription handler (implements Nex.Handler ).","ref":"Nex.Handlers.SubscriptionHander.html","title":"Nex.Handlers.SubscriptionHander","type":"module"},{"doc":"Messages context module. This is the main interface for storing and retrieving events from the database.","ref":"Nex.Messages.html","title":"Nex.Messages","type":"module"},{"doc":"Inserts the given event parameters to the database.","ref":"Nex.Messages.html#insert_event/1","title":"Nex.Messages.insert_event/1","type":"function"},{"doc":"Inserts the given event parameters to the database, and deletes previous events of the same kind from the same author. Use this for storing contact lists and metadata events.","ref":"Nex.Messages.html#insert_event_and_drop_previous/1","title":"Nex.Messages.insert_event_and_drop_previous/1","type":"function"},{"doc":"Inserts the given event parameters to the database, and deletes events referenced in e tags. Use this for NIP-09 events.","ref":"Nex.Messages.html#insert_event_and_drop_tagged/1","title":"Nex.Messages.insert_event_and_drop_tagged/1","type":"function"},{"doc":"Lists events by the given list of filters. Multiple conditions in the same filter are AND conditions. Multiple filters are OR conditions. See Nex.Messages.Filter for details fo a valid filter.","ref":"Nex.Messages.html#list_events/1","title":"Nex.Messages.list_events/1","type":"function"},{"doc":"As f:list_events/1 but streams the query results. The given callback function is invoked for each event row.","ref":"Nex.Messages.html#stream_events/2","title":"Nex.Messages.stream_events/2","type":"function"},{"doc":"Nex DBTag schema. Nex stores the first two fields of every tag as a seperate row in the database to enable more perfomant querying on tags.","ref":"Nex.Messages.DBTag.html","title":"Nex.Messages.DBTag","type":"module"},{"doc":"Returns a changeset from the given params.","ref":"Nex.Messages.DBTag.html#changeset/2","title":"Nex.Messages.DBTag.changeset/2","type":"function"},{"doc":"Nostr Event schema. See NIP-01 .","ref":"Nex.Messages.Event.html","title":"Nex.Messages.Event","type":"module"},{"doc":"Calculates the ID for the given event. Returns a hex-encoded ID.","ref":"Nex.Messages.Event.html#calc_id/1","title":"Nex.Messages.Event.calc_id/1","type":"function"},{"doc":"Returns a changeset from the given params. This base changeset validates the presents and format of all fields, but does not verify the event ID or signature.","ref":"Nex.Messages.Event.html#changeset/2","title":"Nex.Messages.Event.changeset/2","type":"function"},{"doc":"Returns the ID preimage for the given event. Clients will sign this value.","ref":"Nex.Messages.Event.html#id_preimage/1","title":"Nex.Messages.Event.id_preimage/1","type":"function"},{"doc":"Guard returning true if the given kind is of any ephemeral event.","ref":"Nex.Messages.Event.html#is_ephemeral_kind/1","title":"Nex.Messages.Event.is_ephemeral_kind/1","type":"macro"},{"doc":"Guard returning true if the given kind is of any replaceable event.","ref":"Nex.Messages.Event.html#is_replacable_kind/1","title":"Nex.Messages.Event.is_replacable_kind/1","type":"macro"},{"doc":"Returns a changeset from the given params. As f:changeset/2 but also verifies the event ID and signature.","ref":"Nex.Messages.Event.html#verify_changeset/2","title":"Nex.Messages.Event.verify_changeset/2","type":"function"},{"doc":"Event","ref":"Nex.Messages.Event.html#t:t/0","title":"Nex.Messages.Event.t/0","type":"type"},{"doc":"Nostr Message schema. This module is used both to cast raw filter maps into an internal format, and also to match events against those filters.","ref":"Nex.Messages.Filter.html","title":"Nex.Messages.Filter","type":"module"},{"doc":"Casts the map of filter consitions into a structured map. Specfically Nex turns tag conditions (any filter beginning with &quot;#&quot;) into a list of tuples for simpler query building and filtering.","ref":"Nex.Messages.Filter.html#cast/1","title":"Nex.Messages.Filter.cast/1","type":"function"},{"doc":"Returns true if any of the list of filters matches the given event.","ref":"Nex.Messages.Filter.html#match_any?/2","title":"Nex.Messages.Filter.match_any?/2","type":"function"},{"doc":"Returns true if the filter matches the given event.","ref":"Nex.Messages.Filter.html#match_event?/2","title":"Nex.Messages.Filter.match_event?/2","type":"function"},{"doc":"Returns true if the filter is valid (not empty!)","ref":"Nex.Messages.Filter.html#valid?/1","title":"Nex.Messages.Filter.valid?/1","type":"function"},{"doc":"Filter","ref":"Nex.Messages.Filter.html#t:t/0","title":"Nex.Messages.Filter.t/0","type":"type"},{"doc":"Tag","ref":"Nex.Messages.Filter.html#t:tag/0","title":"Nex.Messages.Filter.tag/0","type":"type"},{"doc":"Nostr Message schema. Use this module to decode and encode message strings passed over the websocket connection. Internally Nex passes messages around as tuples so we can take advantage of pattern matching.","ref":"Nex.Messages.Msg.html","title":"Nex.Messages.Msg","type":"module"},{"doc":"Decodes the given message string into a tuple.","ref":"Nex.Messages.Msg.html#decode/1","title":"Nex.Messages.Msg.decode/1","type":"function"},{"doc":"Encodes the given message tuple into a string.","ref":"Nex.Messages.Msg.html#encode/1","title":"Nex.Messages.Msg.encode/1","type":"function"},{"doc":"Message","ref":"Nex.Messages.Msg.html#t:t/0","title":"Nex.Messages.Msg.t/0","type":"type"},{"doc":"Nostr Tag schema. A Nostr Tag is simply a list of strings. This module defines the type and provides convinience functions for finding tags or conveting a tag to a map of parameters.","ref":"Nex.Messages.Tag.html","title":"Nex.Messages.Tag","type":"module"},{"doc":"Filters the list of tags by the given name.","ref":"Nex.Messages.Tag.html#filter_by_name/2","title":"Nex.Messages.Tag.filter_by_name/2","type":"function"},{"doc":"Finds the first tag from the list by the given name.","ref":"Nex.Messages.Tag.html#find_by_name/2","title":"Nex.Messages.Tag.find_by_name/2","type":"function"},{"doc":"Returns the first two elements of the tag as a map of name and value.","ref":"Nex.Messages.Tag.html#to_map/1","title":"Nex.Messages.Tag.to_map/1","type":"function"},{"doc":"Tag","ref":"Nex.Messages.Tag.html#t:t/0","title":"Nex.Messages.Tag.t/0","type":"type"},{"doc":"Nex Plug module. There are two ways for Nex to be run: As a standalone application (see Readme) As an enpoint embedded within another Plug or Phoenix router forward &quot;/nex&quot; , to : Nex.Plug","ref":"Nex.Plug.html","title":"Nex.Plug","type":"module"},{"doc":"Callback implementation for Plug.call/2 .","ref":"Nex.Plug.html#call/2","title":"Nex.Plug.call/2","type":"function"},{"doc":"Callback implementation for Plug.init/1 .","ref":"Nex.Plug.html#init/1","title":"Nex.Plug.init/1","type":"function"},{"doc":"Nex Plug function - handles all HTTP and websocket connections. Websocket requests are handled by the the Nex.Socket module. HTTP requests with the content-type header of &quot;application/nostr+json&quot; responds with a NIP-11 Relay Information Document.","ref":"Nex.Plug.html#nex/2","title":"Nex.Plug.nex/2","type":"function"},{"doc":"Rate limiter module.","ref":"Nex.RateLimiter.html","title":"Nex.RateLimiter","type":"module"},{"doc":"Iterates over the given list of limits and checks each against the specified action ID.","ref":"Nex.RateLimiter.html#limit/2","title":"Nex.RateLimiter.limit/2","type":"function"},{"doc":"A limit is a tuple containing the scale period (ms) and the limit.","ref":"Nex.RateLimiter.html#t:limit/0","title":"Nex.RateLimiter.limit/0","type":"type"},{"doc":"","ref":"Nex.Release.html","title":"Nex.Release","type":"module"},{"doc":"","ref":"Nex.Release.html#migrate/0","title":"Nex.Release.migrate/0","type":"function"},{"doc":"","ref":"Nex.Release.html#rollback/2","title":"Nex.Release.rollback/2","type":"function"},{"doc":"Websocket handler implementing the WebSock behaviour.","ref":"Nex.Socket.html","title":"Nex.Socket","type":"module"},{"doc":"","ref":"Nex.Socket.html#t:t/0","title":"Nex.Socket.t/0","type":"type"},{"doc":"Utility function to assist finding and verifying delegation tags used in NIP-26 .","ref":"Nex.Utils.DelegatedEvents.html","title":"Nex.Utils.DelegatedEvents","type":"module"},{"doc":"Returns true if the Event contains a delegation tag.","ref":"Nex.Utils.DelegatedEvents.html#delegated_event?/1","title":"Nex.Utils.DelegatedEvents.delegated_event?/1","type":"function"},{"doc":"Returns true if the Event contains a valid delegation tag. A delegation tag is valid if it's conditions match the event it is contained in, and the signature verifies.","ref":"Nex.Utils.DelegatedEvents.html#valid_delegated_event?/1","title":"Nex.Utils.DelegatedEvents.valid_delegated_event?/1","type":"function"},{"doc":"","ref":"Nex.Utils.DelegatedEvents.html#valid_delegated_event?/2","title":"Nex.Utils.DelegatedEvents.valid_delegated_event?/2","type":"function"}]